<?php
$path = preg_replace('/wp-content.*$/', '', __DIR__);
include($path . 'wp-load.php');

global $wpdb;
$table_name = $wpdb->prefix . "responser";

function get_all_pages($action, $search = null, $site_key = null) {
  global $wpdb;
  $table_name = $wpdb->prefix . "responser";
  $get_all_pages = $wpdb->get_results("SELECT * FROM $table_name");
  $get_exists_pages = [];
  if ($action === 'edit') {
    $get_exists_pages = $wpdb->get_results("SELECT * FROM $table_name WHERE site_key = '$site_key'");
  }

  $page_ids = [];
  $exists_page_ids = [];
  $return_pages = [];
  $query_params = ['posts_per_page' => -1, 'post_type' => 'page'];
  $edit_query_params = ['posts_per_page' => -1, 'post_type' => 'page'];

  if ($action === 'search' && $search) {
    $query_params['s'] = esc_attr($search);
    $edit_query_params['s'] = esc_attr($search);
  }

  if (sizeof($get_all_pages) > 0) {
    foreach ($get_all_pages as $page) {
      $pid = get_page_by_title($page->page_name);
      $page_ids[] = $pid->ID;
    }
    $query_params['post__not_in'] = $page_ids;
  }

  if (sizeof($get_exists_pages) > 0) {
    foreach ($get_exists_pages as $page) {
      $pid = get_page_by_title($page->page_name);
      $exists_page_ids[] = $pid->ID;
    }
    $edit_query_params['post__in'] = $exists_page_ids;
  }

  if ($action === 'edit') {
    $includes_query = new WP_Query($edit_query_params);

    if ($includes_query->have_posts()) {
      $index = 0;
      while ($includes_query->have_posts()) : $includes_query->the_post();
        $return_pages[$index]['page'] = get_the_title();
        $return_pages[$index]['checked'] = true;
        $index++;
      endwhile;
      wp_reset_postdata();
    }
  }

  $pages_query = new WP_Query($query_params);

  if ($pages_query->have_posts()) {
    $index = count($return_pages);
    while ($pages_query->have_posts()) : $pages_query->the_post();
      $return_pages[$index]['page'] = get_the_title();
      $index++;
    endwhile;
    wp_reset_postdata();
  }
  return $return_pages;
}

switch ($_POST['action']) {
  case "getCodes": 
    if (isset($_POST['type']) && $_POST['type'] === 'search' && isset($_POST['searchText'])) {
      $query = "SELECT * FROM $table_name WHERE site_key like '%" . $_POST['searchText'] . "%' GROUP BY site_key";
    } else {
      $query = "SELECT * FROM $table_name GROUP BY site_key";
    }
    
    $result = $wpdb->get_results($query);
    if (isset($result)) {
      echo json_encode(array("statusCode" => 200, "data" => $result));
    } else {
      echo json_encode(array("statusCode" => 400, "error" => 'Something went wrong!!'));
    }
    break;
  case "getPages":

    if (isset($_POST['type'])) {
      $return_pages = [];
      if ($_POST['type'] === 'search' && isset($_POST['search'])) {
        $return_pages = get_all_pages('search', $_POST['search']);
      } else if ($_POST['type'] === 'add') {
        $return_pages = get_all_pages($_POST['type']);
      } else if ($_POST['type'] === 'edit' && isset($_POST['siteKey'])) {
        $return_pages = get_all_pages($_POST['type'], null, $_POST['siteKey']);
      }
      echo json_encode(array('statusCode' => 200, 'data' => $return_pages));
    } else {
      echo json_encode(array('statusCode' => 200, 'error' => 'Something went wrong!!'));
    }

    break;
  case "getPagesBySiteKey":
    $get_exists_pages = [];
    if (isset($_POST['siteKey'])) {
      $site_key = $_POST['siteKey'];
      $get_exists_pages = $wpdb->get_results("SELECT * FROM $table_name WHERE site_key = '$site_key'");
    }
    if (count($get_exists_pages) > 0) {
      echo json_encode(array('statusCode' => 200, 'data' => $get_exists_pages));
    } else {
      echo json_encode(array('statusCode' => 200, 'error' => 'Something went wrong!!'));
    }

    break;
  case "create":

    if (isset($_POST['code']) && isset($_POST['pages'])) {
      $pages = $_POST['pages'];
      $site_key = $_POST['code'];
      $title = $_POST['title'];
      $inserted_count = 0;
      $exists_pages = 0;

      foreach ($pages as $page) {
        $result = $wpdb->get_results("SELECT * FROM $table_name WHERE page_name = '$page'");
        if (isset($result) && count($result) === 0) {
          $res = $wpdb->insert($table_name, array(
            'page_name' => $page,
            'site_key' => $site_key,
            'title' => $title,
          ));
          if ($res && $res === 1) {
            $inserted_count++;
          }
        } else {
          $exists_pages++;
        }
      }

      if ($inserted_count > 0) {
        echo json_encode(array("statusCode" => 200));
      } else if ($exists_pages > 0) {
        echo json_encode(array("statusCode" => 400, "error" => 'Page(s) already exists!!'));
      } else {
        echo json_encode(array("statusCode" => 400, "error" => 'Something went wrong!!'));
      }
    } else {
      echo json_encode(array("statusCode" => 400, "error" => 'Something went wrong!!'));
    }

    break;

  case "update":
    if(isset($_POST['update_code']) && isset($_POST['update_pages']))
    {
    $site_key = $_POST['site_key'];
    
    $results = $wpdb->get_results("SELECT * FROM $table_name WHERE site_key = '$site_key'");
    foreach($results as $result)
    {
      $wpdb->query("DELETE FROM $table_name WHERE site_key = '$result->site_key'");
    }
    
    foreach($_POST['update_pages'] as $page) 
    {
    $update_res = $wpdb->insert($table_name, array(
      'page_name' => $page,
      'site_key' => $_POST['update_code'],
      'title' => $_POST['title'],
    ));
    }
    if(isset($update_res))
     {
      echo json_encode(array("statusCode" => 200));
     }
     else
     {
      echo json_encode(array("statusCode" => 400, "error" => 'Something went wrong!!')); 
     }
    }
    break;

  case "delete":
    if (isset($_POST['siteKey'])) {

      $site_key = $_POST['siteKey'];
      $result = $wpdb->query("DELETE FROM $table_name WHERE site_key = '$site_key'");

      if (isset($result)) {
        echo json_encode(array("statusCode" => 200));
      } else {
        echo json_encode(array("statusCode" => 400, 'error' => 'Something went wrong!!'));
      }
    } else {
      echo json_encode(array("statusCode" => 400, 'error' => 'Something went wrong!!'));
    }

    break;

  case "deletePage":
    if (isset($_POST['pageId'])) {

      $id = $_POST['pageId'];
      $result = $wpdb->query("DELETE FROM $table_name WHERE id = $id");

      if (isset($result)) {
        echo json_encode(array("statusCode" => 200));
      } else {
        echo json_encode(array("statusCode" => 400, 'error' => 'Something went wrong!!'));
      }
    } else {
      echo json_encode(array("statusCode" => 400, 'error' => 'Something went wrong!!'));
    }
    break;
}
