<script>
    $(document).ready(function() {

        function handleTimeout(that) {
            setTimeout(function() {
                const html = that.closest('.JS-card-content').find('.JS-init-step').html();
                that.closest('.JS-card-content').html('<div class="JS-init-step">' + html + '</div>');

            }, 2000);
            getCodes();
        }

        function renderAddCodeHTML() {
            const remainPages = getRemainPages();

            let html = '<div class="code-card add-card">';
            html += '<div class="add-form JS-card-content" data-action="add" data-current-step="1">';
            html += '<div class="JS-init-step">';
            html += '<img class="responser-logo" src="<?php echo plugins_url('/responser/assets/img/logo-medium.png'); ?>">';
            if (remainPages && remainPages.length > 0) {
                html += '<button type="button" class="btn-add JS-form-enable">Add Site Key</button>';
            } else {
                html += '<h3>All Page(s) are mapped with keys!!</h3>';
            }
            html += '</div>'
            html += '</div>'
            html += '</div>'

            return html;
        }

        function renderSinglePageHTML(page) {
            let html = '<div class="page-single">';
            html += '<span>' + page.page_name + '</span>';
            html += '<button class="btn btn-delete JS-btn-delete-page" data-page-id="' + page.id + '"><i class="fa fa-times"></i></button>';
            html += '</div>';
            return html;
        }

        function renderSingleCodeHTML(code) {
            let exists_pages = [];
            if (code.site_key) {
                exists_pages = getPagesBySiteKey(code.site_key);
            }

            let html = '<div class="code-card JS-card edit-card">';
            html += '<div class="JS-card-content" data-action="edit" data-current-step="1" data-site-key="' + code.site_key + '">';
            html += '<div class="JS-init-step">';
            html += '<div class="code-card-header">';
            html += '<h2> ' + code.title + ' (' + code.site_key + ')</h2>';
            html += '<div class="code-card-actions">';
            html += '<button class="btn btn-edit JS-form-enable"><i class="fa fa-pencil"></i></button>';
            html += '<button class="btn btn-delete JS-btn-delete-code"><i class="fa fa-trash"></i></button>';
            html += '</div>';
            html += '</div>';
            html += '<div class="code-card-body">';

            if (exists_pages && exists_pages.length > 0) {
                html += '<div class="page-list JS-page-list" data-total-pages="' + exists_pages.length + '">';
                $.each(exists_pages, function(index, page) {
                    html += renderSinglePageHTML(page);
                });
                html += '</div>';
            }
            html += '</div>';
            html += '</div>';
            html += '</div>';
            html += '</div>';
            return html;
        }

        function renderCodeHTML(codes) {
            let html = renderAddCodeHTML();
            if (codes && codes.length > 0) {
                $.each(codes, function(index, code) {
                    html += renderSingleCodeHTML(code);
                });
            }
            $('#code-list').html(html);
        }

        function renderPagesHTML(that, data) {
            let html = '<ul>';
            if (data && data.length > 0) {
                $.each(data, function(i, val) {
                    const checked = val.checked ? 'checked' : '';
                    html += "<li><input type='checkbox' class='JS-pages-list' name='pages_list' value='" + val.page + "' " + checked + " /> " + val.page + "</li>";
                });
            } else {
                html += "<li>No Pages found</li>";
            }
            html += '</ul>';
            that.closest('.JS-card-content').children('.JS-step-2').find('.JS-search-pages').html(html);
        }

        function getCodes(searchText) {
            const payload = {
                action: 'getCodes',
            }
            if (searchText) {
                payload.type = "search";
                payload.searchText = searchText;
            }
            const response = ajax_call('POST', payload);

            if (response && response.statusCode === 200) {
                renderCodeHTML(response.data);
            }
        }

        function getRemainPages() {
            let remainPages = [];
            const payload = {
                action: 'getPages',
                type: 'add',
            }
            const response = ajax_call('POST', payload);

            if (response && response.statusCode === 200) {
                remainPages = response.data;
            }
            return remainPages;
        }

        function getPagesBySiteKey(siteKey) {
            let pages = [];
            if (siteKey) {
                const payload = {
                    action: 'getPagesBySiteKey',
                    siteKey: siteKey,
                }
                const response = ajax_call('POST', payload);

                if (response && response.statusCode === 200) {
                    pages = response.data;
                }
            }
            return pages;
        }

        // FOR Add / Edit For Enable
        $(document).on('click', ".JS-form-enable", function() {
            const action = $(this).closest('.JS-card-content').attr('data-action');
            const formHTML = $('#JS-form-html').html();

            $(this).closest('.JS-card-content').append(formHTML);
            $(this).closest('.JS-card-content').children('.JS-init-step').hide();
            $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-back').show();

            if (action === 'edit') {
                const site_key = $(this).closest('.JS-card-content').attr('data-site-key');
                $(this).closest('.JS-card-content').find('.JS-step-1').find('.JS-site-key').val(site_key);
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-next').removeAttr('disabled');
            }
        });

        // FOR Back Button
        $(document).on('click', ".JS-btn-back", function() {
            const currentStep = Number($(this).closest('.JS-card-content').attr('data-current-step'));
            if (currentStep === 1) {
                const html = $(this).closest('.JS-card-content').children('.JS-init-step').html();
                $(this).closest('.JS-card-content').html('<div class="JS-init-step">' + html + '</div>');
            } else {
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-next').show();
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-save').hide();
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-update').hide();
                $(this).closest('.JS-card-content').children('.JS-step-2').hide();
                $(this).closest('.JS-card-content').children('.JS-step-1').show();
                $(this).closest('.JS-card-content').attr('data-current-step', currentStep - 1);
            }

        });

        // FOR Next Button
        $(document).on('click', ".JS-btn-next", function() {
            const action = $(this).closest('.JS-card-content').attr('data-action');
            const siteKey = $(this).closest('.JS-card-content').attr('data-site-key');

            const currentStep = Number($(this).closest('.JS-card-content').attr('data-current-step'));

            // Check Entered Site key valid or not from responser API
            if (currentStep === 1) {
                const updatedSiteKey = $(this).closest('.JS-card-content').children('.JS-step-1').find('.JS-site-key').val();
                const URL = 'https://api.responser.com/v1/form/verifyByCode';
                const responserPayload = {
                    code: updatedSiteKey,
                }

                const verifyCodePromise = new Promise((resolve, reject) => {
                    const res = ajax_call('POST', responserPayload, URL)
                    if (res && res.responseJSON && res.responseJSON.statusCode === 404) {
                        $(this).closest('.JS-card-content').children('.JS-step-1').find('.Js-site-key-error').show();
                    } else if (res && res._id) {
                        resolve(res);
                    }
                });

                const that = $(this);
                verifyCodePromise.then(function(form) {
                    that.closest('.JS-card-content').children('.JS-step-1').find('.JS-form-title').val(form.name);
                    that.closest('.JS-card-content').children('.JS-step-1').find('.Js-site-key-error').hide();
                    that.closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-back').show();

                    that.closest('.JS-card-content').children('.JS-step-2').show();
                    that.closest('.JS-card-content').children('.JS-step-1').hide();
                    that.closest('.JS-card-content').attr('data-current-step', currentStep + 1);
                    that.hide();

                    const payload = {
                        action: 'getPages',
                        type: action,
                    };

                    if (action === 'edit') {
                        payload.siteKey = siteKey;
                        that.closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-save').hide();
                        that.closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-update').show();
                    } else {
                        that.closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-save').show();
                    }

                    const response = ajax_call('POST', payload);

                    if (response && response.statusCode === 200) {
                        renderPagesHTML(that, response.data);
                    }
                });
            }
        });

        // FOR Save Code
        $(document).on('click', ".JS-btn-save", function() {
            const site_key = $(this).closest('.JS-card-content').children('.JS-step-1').find('.JS-site-key').val();
            const formTitle = $(this).closest('.JS-card-content').children('.JS-step-1').find('.JS-form-title').val();
            const selected_pages = [];
            $(this).closest('.JS-card-content').children('.JS-step-2').find('input.JS-pages-list:checkbox:checked').each(function() {
                selected_pages.push($(this).val());
            });
            const response = ajax_call('POST', {
                action: 'create',
                code: site_key,
                title: formTitle,
                pages: selected_pages,
            });
            if (response) {
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-back').hide();
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-next').hide();
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-save').hide();
                $(this).closest('.JS-card-content').children('.JS-step-2').hide();
                handleTimeout($(this));
                if (response.statusCode === 200) {
                    $(this).closest('.JS-card-content').children('.JS-step-success').find('.JS-success-message').text('Code Added Successfully!!');
                    $(this).closest('.JS-card-content').children('.JS-step-success').show();
                } else {
                    $(this).closest('.JS-card-content').children('.JS-step-error').find('.JS-error-message').text(response.error);
                    $(this).closest('.JS-card-content').children('.JS-step-error').show();
                }

            }
        });

        //Checkbox Checked after Update Show.

        $(document).on('change', ".JS-pages-list", function() {
            const selected_pages = [];
            $(this).closest('.JS-card-content').children('.JS-step-2').find('input.JS-pages-list:checkbox:checked').each(function() {
                selected_pages.push($(this).val());
            });
            if (selected_pages.length === 0) {
                $(this).closest('.JS-card-content').find('.JS-btn-section').find('.JS-btn-update').attr('disabled', true);
            } else {
                $(this).closest('.JS-card-content').find('.JS-btn-section').find('.JS-btn-update').removeAttr('disabled');
            }
        });

        // FOR Edit Code
        $(document).on('click', ".JS-btn-update", function() {
            const siteKey = $(this).closest('.JS-card-content').attr('data-site-key');
            const update_site_key = $(this).closest('.JS-card-content').children('.JS-step-1').find('.JS-site-key').val();
            const formTitle = $(this).closest('.JS-card-content').children('.JS-step-1').find('.JS-form-title').val();
            const update_selected_pages = [];

            $(this).closest('.JS-card-content').children('.JS-step-2').find('input.JS-pages-list:checkbox:checked').each(function() {
                update_selected_pages.push($(this).val());
            });

            if (update_selected_pages.length > 0) {
                const response = ajax_call('POST', {
                    action: 'update',
                    site_key: siteKey,
                    title: formTitle,
                    update_code: update_site_key,
                    update_pages: update_selected_pages,
                });
                getCodes();
            }

        });

        // FOR Delete Code
        $(document).on('click', ".JS-btn-delete-code", function() {
            const siteKey = $(this).closest('.JS-card-content').attr('data-site-key');
            if (siteKey) {
                const response = ajax_call('POST', {
                    action: 'delete',
                    siteKey: siteKey,
                });

                if (response && response.statusCode === 200) {
                    $(this).closest('.JS-card').remove();

                }
                getCodes();
            }
        });

        // FOR Delete Page
        $(document).on('click', ".JS-btn-delete-page", function() {
            const pageId = $(this).attr('data-page-id');
            const totalPages = $(this).closest('.JS-page-list').attr('data-total-pages');

            if (pageId) {
                const response = ajax_call('POST', {
                    action: 'deletePage',
                    pageId: pageId,
                });

                if (response && response.statusCode === 200) {
                    if (Number(totalPages) === 1) {
                        $(this).closest('.JS-card').remove();
                    } else {
                        $(this).closest('.JS-page-list').attr('data-total-pages', Number(totalPages) - 1);
                        $(this).closest('.page-single').remove();
                    }
                    getCodes();
                }
            }
        });

        // FOR Next Button Enabled/Disabled on value
        $(document).on('keyup', ".JS-site-key", function() {
            if ($(this).val().trim() === '') {
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-next').attr('disabled', true);
            } else {
                $(this).closest('.JS-card-content').children('.JS-btn-section').find('.JS-btn-next').removeAttr('disabled');
            }
        });

        // FOR Search By Code
        $(document).on('keyup', "#search-by-code", function() {
            getCodes($(this).val().trim());
        });

        // FOR Search By Page 
        $(document).on('keyup', ".JS-search-page", function() {
            const response = ajax_call('POST', {
                action: 'getPages',
                type: 'search',
                search: $(this).val().trim(),
            });

            if (response && response.statusCode === 200) {
                renderPagesHTML($(this), response.data);
            }
        });

        // For Get Default Codes
        getCodes();

        // AJAX Common Function 
        function ajax_call(method, payload, outSideUrl = null) {
            let response = null;
            let url = "<?php echo plugins_url() . "/responser/includes/ajax.php" ?>";
            if (outSideUrl) {
                url = outSideUrl;
            }
            $.ajax({
                url,
                type: method,
                data: payload,
                cache: false,
                async: false,
                success: (data) => {
                    if (outSideUrl) {
                        response = data;
                    } else {
                        response = JSON.parse(data);
                    }
                },
                error: (error) => {
                    response = error;
                }
            });
            return response;
        }
    });
</script>