<?php
  /*
  Plugin name: Responser
  Plugin URI: #
  Description: This Plugin use for SiteKey integration in footer.
  Author: Linearloop
  Author URI: #
  Version: 1
  */
register_activation_hook( __FILE__, 'responser_install' );
register_deactivation_hook(__FILE__ ,'responser_uninstall');

// Register the style like for a plugin:

wp_enqueue_style('style', plugins_url( '/assets/css/styles.css', __FILE__ ));
wp_enqueue_style('awesome-min', plugins_url( '/assets/css/font-awesome.min.css', __FILE__ ));
wp_enqueue_style('font-awesome', plugins_url( '/assets/css/font-awesome.css', __FILE__ ));
wp_enqueue_script('jquery.min3', plugins_url( '/assets/js/jquery-3.5.1.min.js', __FILE__ ));

function responser_install() {
	global $wpdb;
	$table_name = $wpdb->prefix . "responser";
	 $sql = 'CREATE TABLE '.$table_name.'(
	    id INTEGER(10) UNSIGNED AUTO_INCREMENT,
	    page_name VARCHAR(255),
	    site_key VARCHAR(255),
	    title VARCHAR(255),
	    PRIMARY KEY  (id))';
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
}

function responser_uninstall() {
	global $wpdb;
	$table_name = $wpdb->prefix . "responser";
	 $sql = 'DROP TABLE '.$table_name;
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql);
}

add_action("admin_menu", "addMenuSetting");

/**
* Register Settings
*/

function addMenuSetting() {
    add_menu_page("Responser", "Responser", 2, "responser", "page",plugin_dir_url( __FILE__ )."assets/img/responser-icon.png");
}

function page() {
	include_once ('includes/list.php');
	include_once ('includes/script.php');
}

add_action('wp_footer','append_script');

function append_script() {
	global $wpdb;
	
	$table_name = $wpdb->prefix . "responser";
	$page_code = $wpdb->get_results( "SELECT * FROM $table_name");

	foreach ($page_code as $code) {
		if(is_page( $code->page_name )) {
			echo '<script src="https://js.responser.com" class="__responser_script__" data-key="'.$code->site_key.'"></script>';
		}	
	}	
}
